IMPLEMENTATION MODULE M2Gen486 ;


IMPORT M2GenStatic486 ;
IMPORT M2GenDyn486 ;
FROM M2Options IMPORT OptimizeDynamic, Statistics ;
FROM M2AS IMPORT Comment ;
FROM M2Quads IMPORT IncDynamicQuads ;


(*
   GenCode - codes the list of quadruples described by Head.
             Checks to see whether we should use dynamic code
             generation or static code generation.
*)

PROCEDURE GenCodeBB (Head, Start, End: CARDINAL) ;
BEGIN
   IF OptimizeDynamic AND M2GenDyn486.IsAbleToCode(Start, End)
   THEN
      IF Statistics
      THEN
         IncDynamicQuads(Start, End)
      END ;
      Comment('Dynamic code generator start') ;
      M2GenDyn486.GenCode(Head, Start, End) ;
      Comment('Dynamic code generator end')
   ELSE
      M2GenStatic486.GenCode(Head, Start, End)
   END
END GenCodeBB ;


(*
   InitializationCode - displays the initialization code.
*)

PROCEDURE InitializationCodeBB ;
BEGIN
   M2GenStatic486.InitializationCode
END InitializationCodeBB ;


(*
   TerminationCode - displays termination code
*)

PROCEDURE TerminationCodeBB ;
BEGIN
   M2GenStatic486.TerminationCode
END TerminationCodeBB ;


END M2Gen486.
